using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

using FT_HANDLE = System.UInt32;
using System.Runtime.InteropServices;

/*

 * Component Naming Convention

    Buttons : bAVT1
              
                b - Button
                A - Port
                V - Value
                T - Test Control
                1 - bit
 
    Fields :  fAVTH
 
                f - Field
                A - Port
                V - Value
                T - Test Control
                H - Hex
 */

namespace USBIO24DLL
{







    public partial class Main : Form
    {







        public enum FT_STATUS//:Uint32
        {
            FT_OK = 0,
            FT_INVALID_HANDLE,
            FT_DEVICE_NOT_FOUND,
            FT_DEVICE_NOT_OPENED,
            FT_IO_ERROR,
            FT_INSUFFICIENT_RESOURCES,
            FT_INVALID_PARAMETER,
            FT_INVALID_BAUD_RATE,
            FT_DEVICE_NOT_OPENED_FOR_ERASE,
            FT_DEVICE_NOT_OPENED_FOR_WRITE,
            FT_FAILED_TO_WRITE_DEVICE,
            FT_EEPROM_READ_FAILED,
            FT_EEPROM_WRITE_FAILED,
            FT_EEPROM_ERASE_FAILED,
            FT_EEPROM_NOT_PRESENT,
            FT_EEPROM_NOT_PROGRAMMED,
            FT_INVALID_ARGS,
            FT_OTHER_ERROR
        };

        
        
        
        
        
        
        
        
        

        public const UInt32 FT_BAUD_300 = 300;
        public const UInt32 FT_BAUD_600 = 600;
        public const UInt32 FT_BAUD_1200 = 1200;
        public const UInt32 FT_BAUD_2400 = 2400;
        public const UInt32 FT_BAUD_4800 = 4800;
        public const UInt32 FT_BAUD_9600 = 9600;
        public const UInt32 FT_BAUD_14400 = 14400;
        public const UInt32 FT_BAUD_19200 = 19200;
        public const UInt32 FT_BAUD_38400 = 38400;
        public const UInt32 FT_BAUD_57600 = 57600;
        public const UInt32 FT_BAUD_115200 = 115200;
        public const UInt32 FT_BAUD_230400 = 230400;
        public const UInt32 FT_BAUD_460800 = 460800;
        public const UInt32 FT_BAUD_921600 = 921600;

        public const UInt32 FT_LIST_NUMBER_ONLY = 0x80000000;
        public const UInt32 FT_LIST_BY_INDEX = 0x40000000;
        public const UInt32 FT_LIST_ALL = 0x20000000;
        public const UInt32 FT_OPEN_BY_SERIAL_NUMBER = 1;
        public const UInt32 FT_OPEN_BY_DESCRIPTION = 2;

        // Word Lengths
        public const byte FT_BITS_8 = 8;
        public const byte FT_BITS_7 = 7;
        public const byte FT_BITS_6 = 6;
        public const byte FT_BITS_5 = 5;

        // Stop Bits
        public const byte FT_STOP_BITS_1 = 0;
        public const byte FT_STOP_BITS_1_5 = 1;
        public const byte FT_STOP_BITS_2 = 2;

        // Parity
        public const byte FT_PARITY_NONE = 0;
        public const byte FT_PARITY_ODD = 1;
        public const byte FT_PARITY_EVEN = 2;
        public const byte FT_PARITY_MARK = 3;
        public const byte FT_PARITY_SPACE = 4;

        // Flow Control
        public const UInt16 FT_FLOW_NONE = 0;
        public const UInt16 FT_FLOW_RTS_CTS = 0x0100;
        public const UInt16 FT_FLOW_DTR_DSR = 0x0200;
        public const UInt16 FT_FLOW_XON_XOFF = 0x0400;

        // Purge rx and tx buffers
        public const byte FT_PURGE_RX = 1;
        public const byte FT_PURGE_TX = 2;

        // Events
        public const UInt32 FT_EVENT_RXCHAR = 1;
        public const UInt32 FT_EVENT_MODEM_STATUS = 2;

        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_ListDevices(void* pvArg1, void* pvArg2, UInt32 dwFlags);	// FT_ListDevices by number only
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_ListDevices(UInt32 pvArg1, void* pvArg2, UInt32 dwFlags);	// FT_ListDevcies by serial number or description by index only
        [DllImport("FTD2XX.dll")]
        static extern FT_STATUS FT_Open(UInt32 uiPort, ref FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_OpenEx(void* pvArg1, UInt32 dwFlags, ref FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern FT_STATUS FT_Close(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe public FT_STATUS FT_Read(FT_HANDLE ftHandle, void* lpBuffer, UInt32 dwBytesToRead, ref UInt32 lpdwBytesReturned);
        [DllImport("FTD2XX.dll")]
        static extern unsafe public FT_STATUS FT_Write(FT_HANDLE ftHandle, void* lpBuffer, UInt32 dwBytesToRead, ref UInt32 lpdwBytesWritten);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetBaudRate(FT_HANDLE ftHandle, UInt32 dwBaudRate);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetDataCharacteristics(FT_HANDLE ftHandle, byte uWordLength, byte uStopBits, byte uParity);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetFlowControl(FT_HANDLE ftHandle, char usFlowControl, byte uXon, byte uXoff);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetDtr(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_ClrDtr(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetRts(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_ClrRts(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_GetModemStatus(FT_HANDLE ftHandle, ref UInt32 lpdwModemStatus);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetChars(FT_HANDLE ftHandle, byte uEventCh, byte uEventChEn, byte uErrorCh, byte uErrorChEn);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_Purge(FT_HANDLE ftHandle, UInt32 dwMask);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetTimeouts(FT_HANDLE ftHandle, UInt32 dwReadTimeout, UInt32 dwWriteTimeout);
        [DllImport("FTD2XX.dll")]
        static extern unsafe public FT_STATUS FT_GetQueueStatus(FT_HANDLE ftHandle, ref UInt32 lpdwAmountInRxQueue);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetBreakOn(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetBreakOff(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_GetStatus(FT_HANDLE ftHandle, ref UInt32 lpdwAmountInRxQueue, ref UInt32 lpdwAmountInTxQueue, ref UInt32 lpdwEventStatus);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetEventNotification(FT_HANDLE ftHandle, UInt32 dwEventMask, void* pvArg);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_ResetDevice(FT_HANDLE ftHandle);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetDivisor(FT_HANDLE ftHandle, char usDivisor);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_GetLatencyTimer(FT_HANDLE ftHandle, ref byte pucTimer);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetLatencyTimer(FT_HANDLE ftHandle, byte ucTimer);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_GetBitMode(FT_HANDLE ftHandle, ref byte pucMode);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetBitMode(FT_HANDLE ftHandle, byte ucMask, byte ucEnable);
        [DllImport("FTD2XX.dll")]
        static extern unsafe FT_STATUS FT_SetUSBParameters(FT_HANDLE ftHandle, UInt32 dwInTransferSize, UInt32 dwOutTransferSize);


        protected UInt32 dwListDescFlags;
        public static UInt32 m_hPort;
        protected Thread pThreadRead;
        protected Thread pThreadWrite;
        protected bool fContinue;




        private IOxxPort PortAVT = new IOxxPort();
        private IOxxPort PortBVT = new IOxxPort();
        private IOxxPort PortCVT = new IOxxPort();

        private IOxxPort PortADT = new IOxxPort();
        private IOxxPort PortBDT = new IOxxPort();
        private IOxxPort PortCDT = new IOxxPort();

        private IOxxPort PortAPT = new IOxxPort();
        private IOxxPort PortBPT = new IOxxPort();
        private IOxxPort PortCPT = new IOxxPort();


        private IOxxPort PortAVP = new IOxxPort();
        private IOxxPort PortBVP = new IOxxPort();
        private IOxxPort PortCVP = new IOxxPort();

        private IOxxPort PortADP = new IOxxPort();
        private IOxxPort PortBDP = new IOxxPort();
        private IOxxPort PortCDP = new IOxxPort();

        private IOxxPort PortAPP = new IOxxPort();
        private IOxxPort PortBPP = new IOxxPort();
        private IOxxPort PortCPP = new IOxxPort();

        private IOxxPort PortAA = new IOxxPort();
        private IOxxPort PortBA = new IOxxPort();
        private IOxxPort PortCA = new IOxxPort();

        private Boolean startup = false;

       // private System.Threading.Thread thdOnSerialRecieve;
        public delegate void ReturnSerialDataCallback(byte[] text, UInt32 dwRet);

        public int gLastTick = 0;


        public Main()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

          //  thdOnSerialRecieve = new System.Threading.Thread(new System.Threading.ThreadStart(RecieveThread));
            
                    
            m_hPort = 0;
            fContinue = false;
            dwListDescFlags = FT_LIST_ALL;
            radSerial.Checked = true;
            btnClose.Enabled = false;
            btnOpen.Enabled = true;
            btnPollPorts.Enabled = false;
            //btnWrite.Enabled = false;
            //button1.Enabled = false;
            radDescription.Enabled = true;
            radSerial.Enabled = true;
            radNumber.Enabled = true;
            tabControl1.Enabled = false;
            label1.Text = "Select Device and Click Open";
            if (ListUnopenDevices() == false)
            {
                MessageBox.Show("Error Listing Devices");
            }

            if (cmbDevList.Items.Count > 0)
                cmbDevList.SelectedIndex = 0;

            AssignVisualControls();
        }


//        unsafe public void RecieveThread()
//        {
//            byte[] receiveBytes = new byte[1024];
//            UInt32 dwRet = 0;
//            UInt32 dwNumBytes;


//            while (true)
//            {
                
//                FT_GetQueueStatus(Main.m_hPort, ref dwRet);

//                dwNumBytes = dwRet;
//                //***********************************************
//                // test to see if there is anything to recieve
//                //***********************************************
//                if (dwRet > 0)
////                if (dwRet == 6)
//                    {
//                    //***********************************************
//                    //Filter data by IP address 
//                    //if from PC IP address ignore 
//                    //else accept incoming data
//                    //***********************************************
//                    fixed (byte* pBuf = receiveBytes)
//                    {
//                        FT_Read(m_hPort, pBuf, dwNumBytes, ref dwRet);
//                    }

//                    ReturnSerialData(receiveBytes, dwRet);

                    
//                }
//            }
//        }


//       public void ReturnSerialData(byte[] UDPData, UInt32 dwRet)
//        {

//       }
///*
//            // Convert data in byte array to string
//            if (this.tbAutoScan.InvokeRequired)
//            {
//                //*************************************************
//                //Need to invoke as the combobox and UDP reciever 
//                //is operating on different threads
//                //*************************************************
//                ReturnSerialDataCallback d = new ReturnSerialDataCallback(ReturnSerialData);

//                //ReturnUDPDataCallback d = new ReturnUDPDataCallback(ReturnUDPData);
//                this.tbAutoScan.Invoke(d, new object[] { UDPData, dwRet });
//            }
//            else
//            {

//                String str = "";

//                byte pinNum = WhichPin(UDPData[1]);

//                int tick;

//                switch (UDPData[0])
//                {

//                    case (byte)'t':
//                        gLastTick = UDPData[1] * 16777216 + UDPData[2] * 65536 + UDPData[3] * 256 + UDPData[4];

//                        str = "Tick Counter = ";
//                        for (int i = 1; i < dwRet; i++)
//                        {
//                            if (UDPData[i] < 16)
//                                str += "0";
//                            str += Convert.ToString(UDPData[i], 16);
//                        }
//                        tbAutoScan.AppendText(str + "\r\n");
//                        break;

//                    case (byte)'A':
//                        if (pinNum > 0)
//                        {
//                            tick = UDPData[2] * 16777216 + UDPData[3] * 65536 + UDPData[4] * 256 + UDPData[5];
//                            str = "Pin [" + Convert.ToString(pinNum, 10) + "] Tick Diff = " + Convert.ToString((tick - gLastTick) * 5, 10) + "ms";
//                            gLastTick = tick;
//                            tbAutoScan.AppendText(str + "\r\n");
//                        }
//                        break;

//                    case (byte)'B':
//                        if (pinNum > 0)
//                        {
//                            tick = UDPData[2] * 16777216 + UDPData[3] * 65536 + UDPData[4] * 256 + UDPData[5];
//                            str = "Pin [" + Convert.ToString(pinNum + 8, 10) + "] Tick Diff = " + Convert.ToString((tick - gLastTick) * 5, 10) + "ms";
//                            gLastTick = tick;
//                            tbAutoScan.AppendText(str + "\r\n");
//                        }
//                        break;

//                    case (byte)'C':
//                        if (pinNum > 0)
//                        {
//                            tick = UDPData[2] * 16777216 + UDPData[3] * 65536 + UDPData[4] * 256 + UDPData[5];
//                            str = "Pin [" + Convert.ToString(pinNum + 16, 10) + "] Tick Diff = " + Convert.ToString((tick - gLastTick) * 5, 10) + "ms";
//                            gLastTick = tick;
//                            tbAutoScan.AppendText(str + "\r\n");
//                        }
//                        break;


//                }




//                //for (int i = 0; i < dwRet; i++)
//                //{
//                //    if (UDPData[i] < 16)
//                //        str += "0";

//                //    str += Convert.ToString(UDPData[i], 16);

//                //    //str += Convert.ToString(UDPData[1], 16);
//                //    //str += Convert.ToString(UDPData[2], 16);
//                //    //str += Convert.ToString(UDPData[3], 16);
//                //    //str += Convert.ToString(UDPData[4], 16);
//                //    //str += Convert.ToString(UDPData[5], 16);

//                //}






//            }
            


//        }
//        */
//        public byte WhichPin(int portVal)
//        {

//            if (portVal == 254)
//                return 1;

//            if (portVal == 253)
//                return 2;

//            if (portVal == 251)
//                return 3;

//            if (portVal == 247)
//                return 4;

//            if (portVal == 239)
//                return 5;

//            if (portVal == 223)
//                return 6;

//            if (portVal == 191)
//                return 7;

//            if (portVal == 127)
//                return 8;

//            return 0;
//        }

//        private void btnStartListenerThread_Click(object sender, EventArgs e)
//        {
//            if (!thdOnSerialRecieve.IsAlive)
//                thdOnSerialRecieve.Start();
//        }

//        private void btnStopListenerThread_Click(object sender, EventArgs e)
//        {
//            thdOnSerialRecieve.Abort();   // Doesn't work well. Need to find a better approach to killing threads.
//        }


        
        private unsafe bool ListUnopenDevices()
        {
            FT_STATUS ftStatus = Main.FT_STATUS.FT_OTHER_ERROR;
            UInt32 numDevs;
            int i;
            byte[] sDevName = new byte[64];
            int iCurrentIndex;
            void* p1;

            iCurrentIndex = cmbDevList.SelectedIndex;
            cmbDevList.Items.Clear();

            p1 = (void*)&numDevs;
            ftStatus = FT_ListDevices(p1, null, FT_LIST_NUMBER_ONLY);

            if (ftStatus == Main.FT_STATUS.FT_OK)
            {
                if (dwListDescFlags == FT_LIST_ALL)
                {
                    for (i = 0; i < numDevs; i++)
                    {
                        cmbDevList.Items.Add(i);
                    }
                }
                else
                {
                    for (i = 0; i < numDevs; i++)
                    {
                        fixed (byte* pBuf = sDevName)
                        {
                            ftStatus = FT_ListDevices((UInt32)i, pBuf, dwListDescFlags);
                            if (ftStatus == Main.FT_STATUS.FT_OK)
                            {
                                string str;
                                System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
                                str = enc.GetString(sDevName, 0, sDevName.Length);
                                cmbDevList.Items.Add(str);
                            }
                            else
                            {
                                MessageBox.Show("Error list devices" + Convert.ToString(ftStatus), "Error");
                                return false;
                            }
                        }
                    }
                }
            }

            cmbDevList.SelectedIndex = iCurrentIndex;

            return true;
        }

        unsafe private void btnOpen_Click(object sender, EventArgs e)
        {
            UInt32 dwOpenFlag;
            uint uiCurrentIndex;
            FT_STATUS ftStatus = Main.FT_STATUS.FT_OTHER_ERROR;

            if (m_hPort == 0)
            {
                dwOpenFlag = dwListDescFlags & ~FT_LIST_BY_INDEX;
                dwOpenFlag = dwListDescFlags & ~FT_LIST_ALL;

                if (dwOpenFlag == 0)
                {
                    uiCurrentIndex = (uint)cmbDevList.SelectedIndex;
                    ftStatus = FT_Open(uiCurrentIndex, ref m_hPort);
                }
                else
                {
                    System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
                    byte[] sDevName = enc.GetBytes(cmbDevList.Text);
                    fixed (byte* pBuf = sDevName)
                    {
                        ftStatus = FT_OpenEx(pBuf, dwOpenFlag, ref m_hPort);
                    }
                }
            }

            if (ftStatus == Main.FT_STATUS.FT_OK)
            {
                // Set up the port
                FT_SetBaudRate(m_hPort, 9600);
                FT_Purge(m_hPort, FT_PURGE_RX | FT_PURGE_TX);
                FT_SetTimeouts(m_hPort, 3000, 3000);
                // Start up the read and write thread
                fContinue = true;
                //pThreadRead = new Thread(new ThreadStart(ReadThread));
                //pThreadRead.Start();
                // Enable buttons that can be pressed
                btnClose.Enabled = true;
                btnOpen.Enabled = false;
                btnPollPorts.Enabled = true;
                radDescription.Enabled = false;
                radSerial.Enabled = false;
                radNumber.Enabled = false;
                tabControl1.Enabled = true;
                label2.Text = "Connection Successful";
            }
            else
            {
                MessageBox.Show("Failed To Open Port" + Convert.ToString(ftStatus));
            }

            PollPortValues();
            PollPortDirections();
            PollPortPullups();

      //      if (!thdOnSerialRecieve.IsAlive)
        //        thdOnSerialRecieve.Start();


        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            if (m_hPort != 0)
            {
                fContinue = false;
                // it will stop in 3 seconds - not sure if this is proper
//                Thread.Sleep(3000);
                FT_Close(m_hPort);
                m_hPort = 0;
                
                
            }
//            radNumber.Checked = true;
            btnClose.Enabled = false;
            btnOpen.Enabled = true;
            btnPollPorts.Enabled = false;
            //btnWrite.Enabled = false;
            radDescription.Enabled = true;
            radSerial.Enabled = true;
            radNumber.Enabled = true;
            tabControl1.Enabled = false;
            label2.Text = "Disconnected";
        }

        private void radNumber_CheckedChanged(object sender, EventArgs e)
        {
            dwListDescFlags = FT_LIST_ALL;
            if (ListUnopenDevices() == false)
            {
                MessageBox.Show("Error Listing Devices");
            }
        }

        private void radSerial_CheckedChanged(object sender, EventArgs e)
        {
            dwListDescFlags = FT_LIST_BY_INDEX | FT_OPEN_BY_SERIAL_NUMBER;
            if (ListUnopenDevices() == false)
            {
                MessageBox.Show("Error Listing Devices");
            }
        }

        private void radDescription_CheckedChanged(object sender, EventArgs e)
        {
            dwListDescFlags = FT_LIST_BY_INDEX | FT_OPEN_BY_DESCRIPTION;
            if (ListUnopenDevices() == false)
            {
                MessageBox.Show("Error Listing Devices");
            }
        }




        private void PortButtonClick(object sender, EventArgs e)
        {
/*    Buttons : bAVT1
              
                b - Button
                A - Port
                V - Value
                T - Test Control
                1 - bit
*/

            Button bttn = (Button)sender;
            string sPort = bttn.Name.Substring(1, 1);
            string sType = bttn.Name.Substring(2, 1);
            string sGroup = bttn.Name.Substring(3, 1);
            string sBit = "";
            if (sType != "A")
                sBit = bttn.Name.Substring(4, 1);
            else
                sBit = bttn.Name.Substring(3, 1);

            switch (sPort)
            {
                case "A" :

                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortAVT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortAVT);
                                    break;

                                case "P":
                                    PortAVP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortAVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortADT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortADT);
                                    break;

                                case "P":
                                    PortADP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortADP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortAPT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortAPT);
                                    break;

                                case "P":
                                    PortAPP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortAPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortAA.BttnClick(int.Parse(sBit));
                            break;

                    }
                    break;



               case "B" :
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortBVT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBVT);
                                    break;

                                case "P":
                                    PortBVP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBDT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBDT);
                                    break;

                                case "P":
                                    PortBDP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBPT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBPT);
                                    break;

                                case "P":
                                    PortBPP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortBPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortBA.BttnClick(int.Parse(sBit));
                            break;
                    }
                    break;



               case "C" :
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortCVT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCVT);
                                    break;

                                case "P":
                                    PortCVP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCDT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCDT);
                                    break;

                                case "P":
                                    PortCDP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCPT.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCPT);
                                    break;

                                case "P":
                                    PortCPP.BttnClick(int.Parse(sBit));
                                    //SendCmd(PortCPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortCA.BttnClick(int.Parse(sBit));
                            break;
                    }
                    break;
             }
        }

        private void PortHexTextChanged(object sender, EventArgs e)
        {
/*    Fields :  fAVTH
 
                f - Field
                A - Port
                V - Value
                T - Test Control
                H - Hex
*/
            TextBox tb = (TextBox)sender;
            string sPort = tb.Name.Substring(1, 1); ;
            string sType = tb.Name.Substring(2, 1); ;
            string sGroup = tb.Name.Substring(3, 1); ;

//            if (startup)
//                return;


            switch (sPort)
            {
                case "A":

                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortAVT.hexTextChange(startup);
                                    //SendCmd(PortAVT);
                                    break;

                                case "P":
                                    PortAVP.hexTextChange(startup);
                                    //SendCmd(PortAVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortADT.hexTextChange(startup);
                                    //SendCmd(PortADT);
                                    break;

                                case "P":
                                    PortADP.hexTextChange(startup);
                                    //SendCmd(PortADP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortAPT.hexTextChange(startup);
                                    //SendCmd(PortAPT);
                                    break;

                                case "P":
                                    PortAPP.hexTextChange(startup);
                                    //SendCmd(PortAPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortAA.hexTextChange(startup);
                            break;

                    }
                    break;



                case "B":
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortBVT.hexTextChange(startup);
                                    //SendCmd(PortBVT);
                                    break;

                                case "P":
                                    PortBVP.hexTextChange(startup);
                                    //SendCmd(PortBVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBDT.hexTextChange(startup);
                                    //SendCmd(PortBDT);
                                    break;

                                case "P":
                                    PortBDP.hexTextChange(startup);
                                    //SendCmd(PortBDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBPT.hexTextChange(startup);
                                    //SendCmd(PortBPT);
                                    break;

                                case "P":
                                    PortBPP.hexTextChange(startup);
                                    //SendCmd(PortBPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortBA.hexTextChange(startup);
                            break;
                    }
                    break;



                case "C":
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortCVT.hexTextChange(startup);
                                    //SendCmd(PortCVT);
                                    break;

                                case "P":
                                    PortCVP.hexTextChange(startup);
                                    //SendCmd(PortCVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCDT.hexTextChange(startup);
                                    //SendCmd(PortCDT);
                                    break;

                                case "P":
                                    PortCDP.hexTextChange(startup);
                                    //SendCmd(PortCDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCPT.hexTextChange(startup);
                                    //SendCmd(PortCPT);
                                    break;

                                case "P":
                                    PortCPP.hexTextChange(startup);
                                    //SendCmd(PortCPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortCA.hexTextChange(startup);
                            break;
                    }
                    break;
            }
        }

        private void PortHexLeave(object sender, EventArgs e)
        {
/*    Fields :  fAVTH
 
                f - Field
                A - Port
                V - Value
                T - Test Control
                H - Hex
*/
            TextBox tb = (TextBox)sender;
            string sPort = tb.Name.Substring(1, 1); ;
            string sType = tb.Name.Substring(2, 1); ;
            string sGroup = tb.Name.Substring(3, 1); ;

            switch (sPort)
            {
                case "A":

                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortAVT.hexLeave();
                                    //SendCmd(PortAVT);
                                    break;

                                case "P":
                                    PortAVP.hexLeave();
                                    //SendCmd(PortAVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortADT.hexLeave();
                                    //SendCmd(PortADT);
                                    break;

                                case "P":
                                    PortADP.hexLeave();
                                    //SendCmd(PortADP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortAPT.hexLeave();
                                    //SendCmd(PortAPT);
                                    break;

                                case "P":
                                    PortAPP.hexLeave();
                                    //SendCmd(PortAPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortAA.hexLeave();
                            break;
                    }
                    break;



                case "B":
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortBVT.hexLeave();
                                    //SendCmd(PortBVT);
                                    break;

                                case "P":
                                    PortBVP.hexLeave();
                                    //SendCmd(PortBVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBDT.hexLeave();
                                    //SendCmd(PortBDT);
                                    break;

                                case "P":
                                    PortBDP.hexLeave();
                                    //SendCmd(PortBDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortBPT.hexLeave();
                                    //SendCmd(PortBPT);
                                    break;

                                case "P":
                                    PortBPP.hexLeave();
                                    //SendCmd(PortBPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortBA.hexLeave();
                            break;
                    }
                    break;



                case "C":
                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortCVT.hexLeave();
                                    //SendCmd(PortCVT);
                                    break;

                                case "P":
                                    PortCVP.hexLeave();
                                    //SendCmd(PortCVP);
                                    break;
                            }
                            break;

                        case "D":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCDT.hexLeave();
                                    //SendCmd(PortCDT);
                                    break;

                                case "P":
                                    PortCDP.hexLeave();
                                    //SendCmd(PortCDP);
                                    break;
                            }
                            break;

                        case "P":
                            switch (sGroup)
                            {
                                case "T":
                                    PortCPT.hexLeave();
                                    //SendCmd(PortCPT);
                                    break;

                                case "P":
                                    PortCPP.hexLeave();
                                    //SendCmd(PortCPP);
                                    break;
                            }
                            break;

                        case "A":
                            PortCA.hexLeave();
                            break;
                    }
                    break;
            }
        }

        unsafe private void PortHexKeyPress(object sender, KeyPressEventArgs e)
        {
            /*    Fields :  fAVTH
 
                            f - Field
                            A - Port
                            V - Value
                            T - Test Control
                            H - Hex
            */
            TextBox tb = (TextBox)sender;
            string sPort = tb.Name.Substring(1, 1); ;
            string sType = tb.Name.Substring(2, 1); ;
            string sGroup = tb.Name.Substring(3, 1); ;

            switch (sPort)
            {
                case "A":

                    switch (sType)
                    {
                        case "V":

                            switch (sGroup)
                            {
                                case "T":
                                    PortAVT.hexKeyPress(e);
                                    break;

                                case "P":
                                    PortAVP.hexKeyPress(e);
                                    break;
                            }

                            break;

                        case "D":

                        case "P":

                            break;

                    }

                    break;



                case "B":



                case "C":

                    break;
            }

        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            ListUnopenDevices();
        }

        private void btnPollPorts_Click(object sender, EventArgs e)
        {
            PollPortValues();

        }
 
        unsafe private void PollPortValues()
        {
            byte portA;
            byte portB;
            byte portC;
            
            portA = ReadValue('a');
            portB = ReadValue('b');
            portC = ReadValue('c');

            PortAVT.tbHex.Text = portA.ToString("X");
            PortBVT.tbHex.Text = portB.ToString("X");
            PortCVT.tbHex.Text = portC.ToString("X");



        }

         unsafe private void PollPortDirections()
        {
            byte portA;
            byte portB;
            byte portC;
            
            portA = ReadDirection('a');
            portB = ReadDirection('b');
            portC = ReadDirection('c');

            PortADT.tbHex.Text = portA.ToString("X");
            PortBDT.tbHex.Text = portB.ToString("X");
            PortCDT.tbHex.Text = portC.ToString("X");

        }
         unsafe private void PollPortPullups()
        {
            byte portA;
            byte portB;
            byte portC;
            
            portA = ReadPullups('a');
            portB = ReadPullups('b');
            portC = ReadPullups('c');

            PortAPT.tbHex.Text = portA.ToString("X");
            PortBPT.tbHex.Text = portA.ToString("X");
            PortCPT.tbHex.Text = portA.ToString("X");

        }
        
            

        unsafe private byte ReadValue(char port)
        {
            UInt32 dwRet = 0;
            FT_STATUS ftStatus = FT_STATUS.FT_OTHER_ERROR;
            byte[] cBuf = new byte[5];
            byte[] rBuf = new byte[5];

            cBuf[0] = (byte)port;

            fixed (byte* pBuf = cBuf)
            {
                ftStatus = FT_Write(m_hPort, pBuf, 1, ref dwRet);
            }
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Write " + Convert.ToString(ftStatus));
            }

            dwRet = 0;
            long timeout;
            timeout = 0;

            UInt32 rxCount;

            rxCount = 1;
            do
            {
                ftStatus = FT_GetQueueStatus(m_hPort, ref dwRet);
                timeout++;
            } while ((dwRet != rxCount) && (timeout < 100000));

            if (timeout == 100000)
            {
                //MessageBox.Show("Timeout while reading " + Convert.ToString(ftStatus));
                return 0;
            }



            fixed (byte* pBuf = rBuf)
            {
                ftStatus = FT_Read(m_hPort, pBuf, rxCount, ref dwRet);
            }

            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Read " + Convert.ToString(ftStatus));
            }

            return (rBuf[0]);

        }

        unsafe private byte ReadDirection(char port)
        {
            UInt32 dwRet = 0;
            FT_STATUS ftStatus = FT_STATUS.FT_OTHER_ERROR;
            byte[] cBuf = new byte[5];
            byte[] rBuf = new byte[5];

            cBuf[0] = (byte)'!';
            cBuf[1] = (byte)port;

            fixed (byte* pBuf = cBuf)
            {
                ftStatus = FT_Write(m_hPort, pBuf, 2, ref dwRet);
            }
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Write " + Convert.ToString(ftStatus));
            }

            dwRet = 0;
            long timeout;
            timeout = 0;

            UInt32 rxCount;

            rxCount = 1;
            do
            {
                ftStatus = FT_GetQueueStatus(m_hPort, ref dwRet);
                timeout++;
            } while ((dwRet != rxCount) && (timeout < 100000));

            if (timeout == 100000)
            {
                //MessageBox.Show("Timeout while reading " + Convert.ToString(ftStatus));
                return 0;
            }



            fixed (byte* pBuf = rBuf)
            {
                ftStatus = FT_Read(m_hPort, pBuf, rxCount, ref dwRet);
            }

            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Read " + Convert.ToString(ftStatus));
            }

            return (rBuf[0]);

        }
        unsafe private byte ReadPullups(char port)
        {
            UInt32 dwRet = 0;
            FT_STATUS ftStatus = FT_STATUS.FT_OTHER_ERROR;
            byte[] cBuf = new byte[5];
            byte[] rBuf = new byte[5];

            cBuf[0] = (byte)'#';
            cBuf[1] = (byte)port;

            fixed (byte* pBuf = cBuf)
            {
                ftStatus = FT_Write(m_hPort, pBuf, 2, ref dwRet);
            }
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Write " + Convert.ToString(ftStatus));
            }

            dwRet = 0;
            long timeout;
            timeout = 0;

            UInt32 rxCount;

            rxCount = 1;
            do
            {
                ftStatus = FT_GetQueueStatus(m_hPort, ref dwRet);
                timeout++;
            } while ((dwRet != rxCount) && (timeout < 100000));

            if (timeout == 100000)
            {
                //MessageBox.Show("Timeout while reading " + Convert.ToString(ftStatus));
                return 0;
            }



            fixed (byte* pBuf = rBuf)
            {
                ftStatus = FT_Read(m_hPort, pBuf, rxCount, ref dwRet);
            }

            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Failed To Read " + Convert.ToString(ftStatus));
            }

            return (rBuf[0]);

        }


        private void AssignVisualControls()
        {
            startup = true;

            PortAVT.bits[7] = bAVT7;
            PortAVT.bits[6] = bAVT6;
            PortAVT.bits[5] = bAVT5;
            PortAVT.bits[4] = bAVT4;
            PortAVT.bits[3] = bAVT3;
            PortAVT.bits[2] = bAVT2;
            PortAVT.bits[1] = bAVT1;
            PortAVT.bits[0] = bAVT0;
            PortAVT.tbHex = fAVTH;
            PortAVT.tbDec = fAVTD;
            PortAVT.sOn = "1";
            PortAVT.sOff = "0";
            PortAVT.eepromAddress = 0x00;
            PortAVT.tbHex.Text = "00";
            PortAVT.tbDec.Text = "00";
            PortAVT.txBuffer[0] = (byte)'A';
            PortAVT.txCount = 2;
            PortAVT.rxBuffer[0] = (byte)'a';
            PortAVT.rxCount = 1;
            PortAVT.rxRetCount = 2;

            PortBVT.bits[7] = bBVT7;
            PortBVT.bits[6] = bBVT6;
            PortBVT.bits[5] = bBVT5;
            PortBVT.bits[4] = bBVT4;
            PortBVT.bits[3] = bBVT3;
            PortBVT.bits[2] = bBVT2;
            PortBVT.bits[1] = bBVT1;
            PortBVT.bits[0] = bBVT0;
            PortBVT.tbHex = fBVTH;
            PortBVT.tbDec = fBVTD;
            PortBVT.sOn = "1";
            PortBVT.sOff = "0";
            PortBVT.eepromAddress = 0x00;
            PortBVT.tbHex.Text = "00";
            PortBVT.tbDec.Text = "00";
            PortBVT.txBuffer[0] = (byte)'B';
            PortBVT.txCount = 2;
            PortBVT.rxBuffer[0] = (byte)'b';
            PortBVT.rxCount = 1;
            PortBVT.rxRetCount = 2;


            PortCVT.bits[7] = bCVT7;
            PortCVT.bits[6] = bCVT6;
            PortCVT.bits[5] = bCVT5;
            PortCVT.bits[4] = bCVT4;
            PortCVT.bits[3] = bCVT3;
            PortCVT.bits[2] = bCVT2;
            PortCVT.bits[1] = bCVT1;
            PortCVT.bits[0] = bCVT0;
            PortCVT.tbHex = fCVTH;
            PortCVT.tbDec = fCVTD;
            PortCVT.sOn = "1";
            PortCVT.sOff = "0";
            PortCVT.eepromAddress = 0x00;
            PortCVT.tbHex.Text = "00";
            PortCVT.tbDec.Text = "00";
            PortCVT.txBuffer[0] = (byte)'C';
            PortCVT.txCount = 2;
            PortCVT.rxBuffer[0] = (byte)'c';
            PortCVT.rxCount = 1;
            PortCVT.rxRetCount = 2;



            PortADT.bits[7] = bADT7;
            PortADT.bits[6] = bADT6;
            PortADT.bits[5] = bADT5;
            PortADT.bits[4] = bADT4;
            PortADT.bits[3] = bADT3;
            PortADT.bits[2] = bADT2;
            PortADT.bits[1] = bADT1;
            PortADT.bits[0] = bADT0;
            PortADT.tbHex = fADTH;
            PortADT.tbDec = fADTD;
            PortADT.sOn = "1";
            PortADT.sOff = "0";
            PortADT.eepromAddress = 0x00;
            PortADT.tbHex.Text = "00";
            PortADT.tbDec.Text = "00";
            PortADT.txBuffer[0] = (byte)'!';
            PortADT.txBuffer[1] = (byte)'A';
            PortADT.txCount = 3;
            PortADT.rxBuffer[0] = (byte)'!';
            PortADT.rxBuffer[1] = (byte)'a';
            PortADT.rxCount = 2;
            PortADT.rxRetCount = 3;


            PortBDT.bits[7] = bBDT7;
            PortBDT.bits[6] = bBDT6;
            PortBDT.bits[5] = bBDT5;
            PortBDT.bits[4] = bBDT4;
            PortBDT.bits[3] = bBDT3;
            PortBDT.bits[2] = bBDT2;
            PortBDT.bits[1] = bBDT1;
            PortBDT.bits[0] = bBDT0;
            PortBDT.tbHex = fBDTH;
            PortBDT.tbDec = fBDTD;
            PortBDT.sOn = "1";
            PortBDT.sOff = "0";
            PortBDT.eepromAddress = 0x00;
            PortBDT.tbHex.Text = "00";
            PortBDT.tbDec.Text = "00";
            PortBDT.txBuffer[0] = (byte)'!';
            PortBDT.txBuffer[1] = (byte)'B';
            PortBDT.txCount = 3;
            PortBDT.rxBuffer[0] = (byte)'!';
            PortBDT.rxBuffer[1] = (byte)'b';
            PortBDT.rxCount = 2;
            PortBDT.rxRetCount = 3;


            PortCDT.bits[7] = bCDT7;
            PortCDT.bits[6] = bCDT6;
            PortCDT.bits[5] = bCDT5;
            PortCDT.bits[4] = bCDT4;
            PortCDT.bits[3] = bCDT3;
            PortCDT.bits[2] = bCDT2;
            PortCDT.bits[1] = bCDT1;
            PortCDT.bits[0] = bCDT0;
            PortCDT.tbHex = fCDTH;
            PortCDT.tbDec = fCDTD;
            PortCDT.sOn = "1";
            PortCDT.sOff = "0";
            PortCDT.eepromAddress = 0x00;
            PortCDT.tbHex.Text = "00";
            PortCDT.tbDec.Text = "00";
            PortCDT.txBuffer[0] = (byte)'!';
            PortCDT.txBuffer[1] = (byte)'C';
            PortCDT.txCount = 3;
            PortCDT.rxBuffer[0] = (byte)'!';
            PortCDT.rxBuffer[1] = (byte)'c';
            PortCDT.rxCount = 2;
            PortCDT.rxRetCount = 3;



            PortAPT.bits[7] = bAPT7;
            PortAPT.bits[6] = bAPT6;
            PortAPT.bits[5] = bAPT5;
            PortAPT.bits[4] = bAPT4;
            PortAPT.bits[3] = bAPT3;
            PortAPT.bits[2] = bAPT2;
            PortAPT.bits[1] = bAPT1;
            PortAPT.bits[0] = bAPT0;
            PortAPT.tbHex = fAPTH;
            PortAPT.tbDec = fAPTD;
            PortAPT.sOn = "1";
            PortAPT.sOff = "0";
            PortAPT.eepromAddress = 0x00;
            PortAPT.tbHex.Text = "00";
            PortAPT.tbDec.Text = "00";
            PortAPT.txBuffer[0] = (byte)'#';
            PortAPT.txBuffer[1] = (byte)'A';
            PortAPT.txCount = 3;
            PortAPT.rxBuffer[0] = (byte)'#';
            PortAPT.rxBuffer[1] = (byte)'a';
            PortAPT.rxCount = 2;
            PortAPT.rxRetCount = 3;


            PortBPT.bits[7] = bBPT7;
            PortBPT.bits[6] = bBPT6;
            PortBPT.bits[5] = bBPT5;
            PortBPT.bits[4] = bBPT4;
            PortBPT.bits[3] = bBPT3;
            PortBPT.bits[2] = bBPT2;
            PortBPT.bits[1] = bBPT1;
            PortBPT.bits[0] = bBPT0;
            PortBPT.tbHex = fBPTH;
            PortBPT.tbDec = fBPTD;
            PortBPT.sOn = "1";
            PortBPT.sOff = "0";
            PortBPT.eepromAddress = 0x00;
            PortBPT.tbHex.Text = "00";
            PortBPT.tbDec.Text = "00";
            PortBPT.txBuffer[0] = (byte)'#';
            PortBPT.txBuffer[1] = (byte)'B';
            PortBPT.txCount = 3;
            PortBPT.rxBuffer[0] = (byte)'#';
            PortBPT.rxBuffer[1] = (byte)'b';
            PortBPT.rxCount = 2;
            PortBPT.rxRetCount = 3;


            PortCPT.bits[7] = bCPT7;
            PortCPT.bits[6] = bCPT6;
            PortCPT.bits[5] = bCPT5;
            PortCPT.bits[4] = bCPT4;
            PortCPT.bits[3] = bCPT3;
            PortCPT.bits[2] = bCPT2;
            PortCPT.bits[1] = bCPT1;
            PortCPT.bits[0] = bCPT0;
            PortCPT.tbHex = fCPTH;
            PortCPT.tbDec = fCPTD;
            PortCPT.sOn = "1";
            PortCPT.sOff = "0";
            PortCPT.eepromAddress = 0x00;
            PortCPT.tbHex.Text = "00";
            PortCPT.tbDec.Text = "00";
            PortCPT.txBuffer[0] = (byte)'#';
            PortCPT.txBuffer[1] = (byte)'C';
            PortCPT.txCount = 3;
            PortCPT.rxBuffer[0] = (byte)'#';
            PortCPT.rxBuffer[1] = (byte)'c';
            PortCPT.rxCount = 2;
            PortCPT.rxRetCount = 3;


            startup = false;

        }



       
        
   

 
    }
}