﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;


namespace USBIO24DLL
{
    class IOxxPort
    {
        // Components
        public System.Windows.Forms.Button[] bits = new System.Windows.Forms.Button[8];
        public System.Windows.Forms.TextBox tbHex;
        public System.Windows.Forms.TextBox tbDec;

        public String sOn;
        public String sOff;
        public byte eepromAddress;

        public byte[] txBuffer = new byte[5];
        public byte txCount;

        public byte[] rxBuffer = new byte[5];
        public byte rxCount;
        public byte rxRetCount;

        public uint PortValue;

        private bool pollingPort;

        System.Windows.Forms.KeyPressEventArgs KeyPressBuffer = new System.Windows.Forms.KeyPressEventArgs((char)0);

        public void BttnClick(int iBit)
        {
            if (bits[iBit].Text == sOff)
            {
                tbDec.Text = (int.Parse(tbDec.Text) + Math.Pow(2, iBit)).ToString();
                bits[iBit].Text = sOn;
            }
            else
            {
                tbDec.Text = (int.Parse(tbDec.Text) - Math.Pow(2, iBit)).ToString();
                bits[iBit].Text = sOff;
            }
            int number = int.Parse(tbDec.Text);
            tbHex.Text = number.ToString("X");


        }

        public void hexTextChange(Boolean bDontSendCmd)
        {
            if (tbHex.Text != "") //Make sure no empty strings are passed
            {

                PortValue = Convert.ToUInt32(tbHex.Text, 16);//int.Parse(PORTADirHex.Text);
                tbDec.Text = PortValue.ToString("d");

                if ((PortValue & 0x01) == 0x01)
                {
                    bits[0].Text = "1";
                }
                else
                {
                    bits[0].Text = "0";
                }
                if ((PortValue & 0x02) == 0x02)
                {
                    bits[1].Text = "1";
                }
                else
                {
                    bits[1].Text = "0";
                }
                if ((PortValue & 0x04) == 0x04)
                {
                    bits[2].Text = "1";
                }
                else
                {
                    bits[2].Text = "0";
                }
                if ((PortValue & 0x08) == 0x08)
                {
                    bits[3].Text = "1";
                }
                else
                {
                    bits[3].Text = "0";
                }
                if ((PortValue & 0x10) == 0x10)
                {
                    bits[4].Text = "1";
                }
                else
                {
                    bits[4].Text = "0";
                }
                if ((PortValue & 0x20) == 0x20)
                {
                    bits[5].Text = "1";
                }
                else
                {
                    bits[5].Text = "0";
                }
                if ((PortValue & 0x40) == 0x40)
                {
                    bits[6].Text = "1";
                }
                else
                {
                    bits[6].Text = "0";
                }
                if ((PortValue & 0x80) == 0x80)
                {
                    bits[7].Text = "1";
                }
                else
                {
                    bits[7].Text = "0";
                }


                //              Send the thing
                if (!bDontSendCmd && !pollingPort)
                    SendCmd();

                if (pollingPort)
                    pollingPort = false;
            }
        }


        public void hexKeyPress(KeyPressEventArgs e)
        {
            if (IsValidChar(e.KeyChar) || Char.IsDigit(e.KeyChar) || e.KeyChar == 8 || e.KeyChar == 13)
            {
                //If the key pressed is a ':' or '-'
                if (e.KeyChar == 13)
                {
                    //If the Text is valid move to the next box
                    if (tbHex.Text != "" && tbHex.Text.Length != tbHex.SelectionLength)
                    {
                        tbHex.Focus();
                    }
                    e.Handled = true;
                }
                else if (tbHex.SelectionLength != tbHex.Text.Length)
                {
                    //Check that the new Text value will be valid
                    // then move on to next box
                    if (tbHex.Text.Length == 1)
                    {
                        if (e.KeyChar != 8)
                        {
                            KeyPressBuffer.KeyChar = e.KeyChar;
                            tbHex.Focus();
                        }
                    }
                }
                //PortValue = Convert.ToUInt32(tbHex.Text, 16);//int.Parse(PORTADirHex.Text);
                //SendCmd();
            }
            else
                e.Handled = true;

        }


        public void hexLeave()
        {
            if (tbHex.Text.Length <= 2)
            {
                if (!IsValidChar(KeyPressBuffer.KeyChar) && !(KeyPressBuffer.KeyChar >= '0' && KeyPressBuffer.KeyChar <= '9'))
                {
                    tbHex.Text = tbHex.Text.PadLeft(2, '0');
                }
            }
            KeyPressBuffer.KeyChar = (char)0;
        }


        private bool IsValidChar(char c)
        {
            if (c >= 'a' && c <= 'f') return true;
            if (c >= 'A' && c <= 'F') return true;
            return false;
        }


        unsafe private void SendCmd()
        {
            UInt32 dwRet = 0;
            Main.FT_STATUS ftStatus = Main.FT_STATUS.FT_OTHER_ERROR;

            byte[] cBuf = new byte[5];

            cBuf[0] = txBuffer[0];
            if (txCount == 2)
                cBuf[1] = (byte)PortValue;
            else if (txCount == 3)
            {
                cBuf[1] = txBuffer[1];
                cBuf[2] = (byte)PortValue;
            }
            else if (txCount == 4)
            {
                cBuf[1] = txBuffer[1];
                cBuf[2] = txBuffer[2];
                cBuf[3] = (byte)PortValue;
            }
            else if (txCount == 5)
            {
                cBuf[1] = txBuffer[1];
                cBuf[2] = txBuffer[2];
                cBuf[3] = txBuffer[3];
                cBuf[4] = (byte)PortValue;
            }

            fixed (byte* pBuf = cBuf)
            {
                ftStatus = Main.FT_Write(Main.m_hPort, pBuf, txCount, ref dwRet);
            }
            if (ftStatus != Main.FT_STATUS.FT_OK)
            {
                //                MessageBox.Show("Failed To Write " + Convert.ToString(ftStatus));
            }
        }


    }
    
}
